<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2017 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.StringUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Arrays"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
String root = request.getContextPath()+"/";

// Toggles the active status of the given role
int roleId = Values.getInt(request.getParameter("role_id"), 0);
String message = "";
String title = "";

DbControl dc = sc.newDbControl();
try
{
	Role role = Role.getById(dc, roleId);
	boolean isInactive = sc.isRoleInactive(roleId);
	boolean changed = sc.setRoleInactive(roleId, !isInactive);

	// Force the menu to re-load
	if (changed)
	{
		sc.setSessionSetting("menu.standard.html", null);
		title = "Role " + (isInactive ? "activated" : "de-activated");
		message = "The '" + HTML.encodeTags(role.getName()) + "' role is now ";
		message += isInactive ? "active." : "inactive.";
	}
	else
	{
		title = "No change";
		message = "The '" + HTML.encodeTags(role.getName()) + "' role is still ";
		message += isInactive ? "de-activated." : "active.";
	}
}
finally
{
	if (dc != null) dc.close();
}
response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&title="+HTML.urlEncode(title)+"&message="+HTML.urlEncode(message));
%>