<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2017 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath()+"/";
final String activePage = request.getParameter("page");
final DbControl dc = sc.newDbControl();
try
{
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String title = "Verify email: "+HTML.encodeTags(user.getEmail());
	String serverUrl = request.getRequestURL().toString().replace(request.getRequestURI(), root);
	sc.setSessionSetting("user", user);
	user.sendEmailVerificationCode(serverUrl);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="~verify_email.js" />
	<base:body>
		<h1><%=title%><base:help helpid="userpreferences.verifyemail" /></h1>
		<form action="submit_user.jsp?ID=<%=ID%>" method="post" name="verify">
		<input type=hidden name="cmd" value="VerifyEmail">

		<div class="content">
			<table class="fullform bottomborder">
			<tr class="align-top">
				<th>Verification code</th>
				<td>
					<input class="text auto-init" data-auto-init="focus" 
						name="verificationCode" id="verificationCode"
						type="text" autocomplete="off"
						maxlength="80" tabindex="0">
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td>
					<div class="messagecontainer note padded">
					You have enabled 2-factor login. Before this can enabled, your
					e-mail address needs to be verified. A 6-digit verification code
					has been sent to <b><%=HTML.encodeTags(user.getEmail())%></b>.
					Please enter this code in the form above.
					</div>
				</td>
			</tr>
			</table>

		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
