<%-- $Id: edit_rawbioassay.jsp 7699 2019-04-11 05:33:36Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.RAWBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	RawBioAssay rawBioAssay = null;
	String name = null;
	boolean hasDbSpots = false;

	boolean deniedPlatform = false;
	Platform currentPlatform = null;
	List<Platform> defaultPlatforms = null;
	PlatformVariant currentVariant = null;
	List<PlatformVariant> defaultVariants = null;
	
	boolean readCurrentBioAssay = true;
	DerivedBioAssay currentBioAssay = null;
	boolean readCurrentExtract = true;
	Extract currentExtract = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	List<Protocol> defaultProtocols = null;
	boolean readCurrentSoftware = true;
	Software currentSoftware = null;
	List<Software> defaultSoftware = null;
	boolean readCurrentArrayDesign = true;
	ArrayDesign currentArrayDesign = null;
	List<ArrayDesign> defaultArrayDesigns = null;
	RawDataType currentRawDataType = null;
	RawDataType defaultRawDataType = null;

	// Load recently used items
	List<Protocol> recentProtocols = cc.getRecent(dc, Item.PROTOCOL);
	List<Software> recentSoftware = cc.getRecent(dc, Item.SOFTWARE);
	List<ArrayDesign> recentArrayDesigns = cc.getRecent(dc, Item.ARRAYDESIGN);
	List<File> recentFiles = cc.getRecent(dc, Item.FILE);
	List<DerivedBioAssay> recentBioAssays = cc.getRecent(dc, Item.DERIVEDBIOASSAY);
	List<Extract> recentExtracts = cc.getRecent(dc, Item.EXTRACT);
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultProtocols = activeProject.findDefaultItems(dc, 
					ItemSubtype.getById(dc, SystemItems.getId(Protocol.FEATURE_EXTRACTION)), false);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultSoftware = activeProject.findDefaultItems(dc, 
					ItemSubtype.getById(dc, SystemItems.getId(Software.FEATURE_EXTRACTION)), false);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultArrayDesigns = activeProject.findDefaultItems(dc, Item.ARRAYDESIGN, true);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultPlatforms = activeProject.findDefaultItems(dc, Item.PLATFORM, true);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultVariants = activeProject.findDefaultItems(dc, Item.PLATFORMVARIANT, true);
		}
		catch (PermissionDeniedException pdex)
		{}
		defaultRawDataType = activeProject.getDefaultRawDataType();
	}
	if (itemId == 0)
	{
		title = "Create raw bioassay";
		cc.removeObject("item");
		
		int currentPlatformId = Values.getInt(cc.getPropertyValue("platform"), 0);
		if (currentPlatformId == 0)
		{
			currentPlatformId = Values.getInt(cc.getRecent(Item.PLATFORM.name(), 0), 0);
		}
		int currentVariantId = Values.getInt(cc.getRecent(Item.PLATFORMVARIANT.name(), 0), 0);
		
		try
		{
			if (currentVariantId != 0) currentVariant = PlatformVariant.getById(dc, currentVariantId);
			if (currentPlatformId != 0) currentPlatform = Platform.getById(dc, currentPlatformId);
		}
		catch (Throwable t)
		{}
		if (currentPlatform == null && currentVariant == null)
		{
			if (defaultVariants != null && defaultVariants.size() > 0)
			{
				currentVariant = defaultVariants.get(0);
				currentPlatform = currentVariant.getPlatform();
			}
			else if (defaultPlatforms != null && defaultPlatforms.size() > 0)
			{
				currentPlatform = defaultPlatforms.get(0);
			}
		}
		
		currentRawDataType = RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
		if (currentRawDataType == null)
		{
			currentRawDataType = RawDataTypes.getRawDataType(cc.getRecent("RawDataType", 0));
		}
		if (currentRawDataType == null) currentRawDataType = defaultRawDataType;

		
		int bioAssayId = Values.getInt(request.getParameter("bioassay_id"));
		if (bioAssayId != 0)
		{
			currentBioAssay = DerivedBioAssay.getById(dc, bioAssayId);
		}
		else if (cc.getPropertyFilter("parentBioAssay.name") != null)
		{
			currentBioAssay = Base.getFirstMatching(dc, DerivedBioAssay.getQuery(), "name", cc.getPropertyFilter("parentBioAssay.name"));
		}
		
		int extractId = Values.getInt(request.getParameter("extract_id"));
		if (extractId != 0)
		{
			currentExtract = Extract.getById(dc, extractId);
		}
		else if (cc.getPropertyFilter("parentExtract.name") != null)
		{
			currentExtract = Base.getFirstMatching(dc, Extract.getQuery(), "name", cc.getPropertyFilter("parentExtract.name"));
		}

		if (currentBioAssay != null)
		{
			name = currentBioAssay.getName() + ".r" + (currentBioAssay.countRawBioAssays() + 1);
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New raw bioassay");
		}

		if (cc.getPropertyFilter("protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("protocol.name"));
		}
		
		if (cc.getPropertyFilter("software.name") != null)
		{
			currentSoftware = Base.getFirstMatching(dc, Software.getQuery(), "name", cc.getPropertyFilter("software.name"));
		}

		if (currentBioAssay != null)
		{
			try
			{
				currentArrayDesign = currentBioAssay.getArrayDesign();
			}
			catch (PermissionDeniedException ex)
			{}
			try
			{
				currentExtract = currentBioAssay.getExtract();
			}
			catch (PermissionDeniedException ex)
			{}
		}
		if (currentArrayDesign == null && cc.getPropertyFilter("arrayDesign.name") != null)
		{
			currentArrayDesign = Base.getFirstMatching(dc, ArrayDesign.getQuery(), "name", cc.getPropertyFilter("arrayDesign.name"));
		}
	}
	else
	{
		rawBioAssay = RawBioAssay.getById(dc, itemId);
		rawBioAssay.checkPermission(Permission.WRITE);
		hasDbSpots = rawBioAssay.getNumDbSpots() > 0;
		cc.setObject("item", rawBioAssay);
		name = rawBioAssay.getName();
		try
		{
			currentRawDataType = rawBioAssay.getRawDataType();
		}
		catch (Throwable t)
		{}
		title = "Edit raw bioassay -- " + HTML.encodeTags(rawBioAssay.getName());
		
		try
		{
			currentPlatform = rawBioAssay.getPlatform();
			currentVariant = rawBioAssay.getVariant();
		}
		catch (PermissionDeniedException ex)
		{
			deniedPlatform = true;
		}
		
		try
		{
			currentBioAssay = rawBioAssay.getParentBioAssay();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioAssay = false;
		}
		try
		{
			currentExtract = rawBioAssay.getParentExtract();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentExtract = false;
		}
		try
		{
			currentProtocol = rawBioAssay.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentSoftware = rawBioAssay.getSoftware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSoftware = false;
		}
		try
		{
			currentArrayDesign = rawBioAssay.getArrayDesign();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArrayDesign = false;
		}
	}
	
	ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	ItemResultList<Platform> platforms = platformQuery.list(dc);

	ItemQuery<PlatformVariant> variantQuery = PlatformVariant.getQuery();
	variantQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	variantQuery.order(Orders.asc(Hql.property("name")));
	variantQuery.restrict(Restrictions.eq(Hql.property("platform"), Hql.entityParameter("platform", Item.PLATFORM)));
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), rawBioAssay);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~bioassays.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		.platform
		{
			font-weight: bold;
			margin-top: 2px;
		}
		</style>
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<div id="page-data" class="datacontainer"
			data-has-db-spots="<%=hasDbSpots ? 1 : 0 %>"
			data-feature-extraction-protocol="<%=SystemItems.getId(Protocol.FEATURE_EXTRACTION)%>"
			data-feature-extraction-software="<%=SystemItems.getId(Software.FEATURE_EXTRACTION)%>"
		></div>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="rawbioassay">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom" active="<%=tabId%>" 
			remember="<%=tabId == null && rawBioAssay != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Raw bioassay" helpid="rawbioassay.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=rawBioAssay == null ? "focus-select" : "focus" %>" 
					type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					maxlength="<%=RawBioAssay.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Platform</th>
				<td>
					<select name="platform" id="platform" class="required"
						<%=deniedPlatform || hasDbSpots ? "disabled" : "" %>>
					<%
					if (deniedPlatform)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						for (Platform p : platforms)
						{
							if (!p.isRemoved() || p.equals(currentPlatform))
							{
								boolean selected = p.equals(currentPlatform) && currentVariant == null;
								RawDataType rdt = p.isFileOnly() ? null : p.getRawDataType();
								%>
								<option class="platform"
									value="PLATFORM:<%=p.getId()%>"
									data-platform="<%=p.getId()%>"
									data-file-only="<%=p.isFileOnly() ? 1 : 0 %>"
									data-raw-data-type="<%=rdt == null ? "" : rdt.getId() %>"
									<%=selected ? "selected" : ""%>><%=HTML.encodeTags(p.getName()) %>
								<%
							}
							variantQuery.setEntityParameter("platform", p);
							List<PlatformVariant> variants = variantQuery.list(dc);
							PlatformVariant lastVariant = variants.size()>0 ? variants.get(variants.size()-1) : null;
							for (PlatformVariant v : variants)
							{
								if ((!v.isRemoved() || v.equals(currentVariant)) && (!p.isRemoved() || p.equals(currentPlatform)))
								{
									boolean selected = v.equals(currentVariant);
									RawDataType rdt = v.isFileOnly() ? null : v.getRawDataType();
									String prefix = v == lastVariant ? " └ " : " ├ ";
									%>
									<option class="variant"
										value="VARIANT:<%=v.getId()%>"
										data-platform="<%=p.getId()%>"
										data-variant="<%=v.getId()%>"
										data-file-only="<%=v.isFileOnly() ? 1 : 0 %>"
										data-raw-data-type="<%=rdt == null ? "" : rdt.getId() %>"
										<%=selected ? "selected" : ""%>><%=prefix%><%=HTML.encodeTags(v.getName()) %>
									<%
								}
							}
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Raw data type</th>
				<td>
					<select name="rawdatatype" class="required"
						<%=hasDbSpots ? "disabled" : "" %>>
					<%
					for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
					{
						if (rdt.isStoredInDb())
						{
							String selected = rdt.equals(currentRawDataType) ? "selected" : "";
							%>
							<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Parent bioassay</th>
				<td>
					<base:select 
						id="bioassay_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioAssay%>"
						denied="<%=!readCurrentBioAssay%>"
						recent="<%=recentBioAssays%>"
						newitem="<%=rawBioAssay == null%>"
						selectrecent="<%=currentExtract == null %>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Parent extract</th>
				<td>
					<base:select 
						id="extract_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentExtract%>"
						denied="<%=!readCurrentExtract%>"
						recent="<%=recentExtracts%>"
						newitem="<%=rawBioAssay == null%>"
						selectrecent="false"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Array design</th>
				<td>
					<base:select 
						id="arraydesign_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentArrayDesign%>"
						data-current-array-design="<%=currentArrayDesign == null ? "" : currentArrayDesign.getId() %>"
						denied="<%=!readCurrentArrayDesign%>"
						recent="<%=recentArrayDesigns%>"
						defaultitems="<%=defaultArrayDesigns%>"
						newitem="<%=rawBioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr id="fiMethod" style="display: none;">
				<th></th>
				<td>
				<select name="fiMethod">
				<option value="">-auto- (array design decides)
				<option value="COORDINATES">Coordinates
				<option value="POSITION">Position
				<option value="FEATURE_ID">Feature ID (*)
				</select>
				<div class="messagecontainer help">
				Select a method for feature identification. <br>
				(*) The Feature ID method only works if the raw data is currently
				connected to an array design which has Feature ID values.
				</div>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol</th>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=rawBioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Software</th>
				<td>
					<base:select 
						id="software_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentSoftware%>"
						denied="<%=!readCurrentSoftware%>"
						recent="<%=recentSoftware%>"
						defaultitems="<%=defaultSoftware%>"
						newitem="<%=rawBioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(rawBioAssay == null ? cc.getPropertyValue("description") : rawBioAssay.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit">
			<jsp:include page="../../common/datafiles/select_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
